dofile"./protocol/GB28181/Script/Lua/SipParser.lua"
dofile"./protocol/GB28181/Script/Lua/SipProcess.lua"
dofile"./protocol/GB28181/Script/Lua/XmlParser.lua"
print("GB28181 parse command file load!!");

ATDebug = function(s)
	ATLuaLog:instance():debug(s .. "\r\n")
end

ATInfo = function(s)
	ATLuaLog:instance():info(s .. "\r\n")
end

ATWarn = function(s)
	ATLuaLog:instance():warn(s .. "\r\n")
end

ATError = function(s)
	ATLuaLog:instance():error(s .. "\r\n")
end

ATUnkown = function(s)
	ATLuaLog:instance():unkown("|" .. s .. "\r\n")
end

--shellע͵һ
--print = ATUnkown

--[[ļ]]
--[[
local f = io.open("debug.txt", "w")
f:write("\n")
f:close()
]]
--[[
ֵ˵
enum ATParserState
{
	ATParser_Success = 0,			///< ɹ
	ATParser_NotComplete = 1,		///< ݲ, Ҫ´½
	ATParser_Failed = 2,			///< ʧ 
	ATParser_MediaData = 3,			///< Ϊý
	ATParser_RepeatMessage = 255,   ///< Ϊظý
};
--]]
messageSet = {}

local firstInChannelID = true
local channels = false
--[[
print = function(s)
local f = io.open("debug.txt", "a")
f:write(s)
f:write("\n")
f:close()
end
--]]
function IdType(Id)
	local IdType = nil
	if #Id == 20 then
		subId = string.sub(Id, 11, 13)
		if subId == "131" then
			IdType = "VideoIn"
		elseif subId == "134" then
			IdType = "AlarmIn"
		else
			IdType = "Other"
		end
	end
	return IdType
end
function AddRecordChannels(id, channels)
	--0.ԭ0ͨ
	if not channels then
		channels = ""
	end
	if channels == "" then
		channels = id
	end
	if not string.find(channels, id) then
		channels = string.gsub(channels, "%[", "")
		channels = string.gsub(channels, "%]", "")
		channels = "["..channels..","..id.."]"	
	end
	return channels
end
--c++
function parseCommand(buf, parseRet) 
	local s = buf:asCString();	
	ATInfo(s);
	if messageSet[s] then
		print("@@@@@@recv a repeat message!!!!!!!!!!!");
		return ATParser_RepeatMessage, buf:len();
	end
	messageSet[s] = 1
----ϢͷλúϢ忪ʼλ
	local endFlag, endFlage = string.find(s, "\r\n\r\n"); 
	if not endFlag then 
		return 2, buf:len()
	end
--		print("check msg is right")
--		local sipValue = {}
--		local ret = parseSip(s, parseRet, sipValue);
--		if not ret then
--			return 2, 0
--		else
--			return 1, 0
--		end
	local sipValue = {}
	local ret = parseSip(string.sub(s, 0, endFlag) , parseRet, sipValue);
	if not ret then
		print("parse sip header error.."..string.sub(s, 0, endFlag));
		return 2, buf:len();
	end
	ret = SipProcess(sipValue, parseRet)
	if not ret then 
		for key,value in pairs(sipValue)  do 
			print(key,"...",value)		
		end
		return 2, 0 
	end
	
	if sipValue["ContentLength"] ~= 0 and sipValue["ContentType"] == "Application/MANSCDP+xml" then
		local xmls, xmle = string.find(s, "%<%?xml ")
		xmle = xmls + sipValue["ContentLength"] - 1;
		local xml = string.sub(s, xmls, xmle);
		--print("xml info:"..xml);
		local xmltable = {}
		parseXml(xml, xmltable)
		local dir = ""
		--printXmlValue(xmltable, dir)
		--xmlϢн
		if xmltable["Notify"] then
			local root = xmltable["Notify"]
			local cmdType = root["CmdType"]["@Data"]
			if cmdType == "Keepalive" then
				ret = OnKeepalive(root, parseRet)
			elseif cmdType == "Alarm" then
				ret = OnAlarm(root, parseRet)
			elseif cmdType == "MediaStatus" then
				ret = OnMediaStatus(root, parseRet)
			end
		elseif xmltable["Response"] then
			local root = xmltable["Response"]
			local cmdType = root["CmdType"]["@Data"]
			ATInfo(cmdType);
			if cmdType == "DeviceInfo" then
				ret = OnDeviceInfo(root, parseRet)
			elseif cmdType == "DeviceStatus" then
				ret = OnDeviceStatus(root, parseRet)
			elseif cmdType == "Catalog" then
				ret = OnCatalog(root, parseRet)
			elseif cmdType == "DeviceControl" then
				ret = OnDeviceControl(root, parseRet)
			elseif cmdType == "RecordInfo" then
				ret = OnRecordInfo(root, parseRet)
			elseif cmdType == "DeviceConfig" then
				ret = OnDeviceConfig(root,parseRet)
			elseif cmdType == "ConfigDownload" then
				ret = OnConfigDownload(root,parseRet)
			end
		end
		--parseRet:pushCString("content", xml)
	end
	
	if not ret then
		return 2, buf:len();
	end;
	
	return 0, buf:len();
end

function OnKeepalive(root, parseRet)
	print("OnKeepalive")
	parseRet:pushCString("_type", "Keepalive")
	
	return true;
end

function OnAlarm(root, parseRet)
	ATInfo("OnAlarm");
	
	-- ǱϱҪ벼ʱͨһ
	alarmId = root["DeviceID"]["@Data"]
	ATInfo("alarmId=" .. alarmId);
	local stepName = ATLuaConfig:instance():getConfig("@_CURRENT_STEP_NAME");
	ATInfo("stepName = ".. stepName);

	if string.find(stepName, "ڵ") then
		expectId = ATLuaConfig:instance():getConfig("ChannelID_ALL")
	elseif string.find(stepName, "IO") then
		expectId = ATLuaConfig:instance():getConfig("AlarmID_ALL")
	end;
	ATInfo("expectId=" .. expectId);

	if alarmId == expectId then
		ATInfo("recv ".. expectId .." Alarm message success!!!!")
		parseRet:pushCString("_type", "Alarm")
		return true;
	end;

	ATInfo("recv an unkown Alarm message!!!!")
	parseRet:pushCString("_type", "Alarm2")
	
	return true;
end

function OnDeviceInfo(root, parseRet)
	print("OnDeviceInfo")
	if root["Result"]["@Data"] == "OK" then
		parseRet:pushCString("@_FACTORY", root["Manufacturer"]["@Data"])
		parseRet:pushCString("@_DEVICE_TYPE", root["Model"]["@Data"])
		parseRet:pushCString("@_SOFTVERSION", root["Firmware"]["@Data"])
		print("_type = ".."DeviceInfo")
		parseRet:pushCString("_type", "DeviceInfo")
	else
		print("OnDeviceInfo Result != OK");
		return false;
	end
	
	return true;
end

function OnDeviceStatus(root, parseRet)
	print("OnDeviceStatus")
	if root["Result"]["@Data"] == "OK" then
		if root["Alarmstatus"] and root["Alarmstatus"]["@Attr"] then
			local alarmId = nil
			num = root["Alarmstatus"]["@Attr"]["Num"] + 0
			if num == 1 then
				alarmId = root["Alarmstatus"]["Item"]["DeviceID"]["@Data"]
			elseif num > 1 then
				alarmId = "["..root["Alarmstatus"]["Item"][1]["DeviceID"]["@Data"]
				for k = 2,num do
					alarmId = alarmId..","
					tempId = root["Alarmstatus"]["Item"][k]["DeviceID"]["@Data"]
					alarmId = alarmId..tempId
				end
				alarmId = alarmId.."]"
			else
				print("alarm status num < 1");
			end
			
			if alarmId then
				parseRet:pushCString("AlarmID_ALL", alarmId)
				print(alarmId)
				local alarmId_Singal;
				if string.find(alarmId, ",") then			     
					-- 1 ͨindexѡһͨб
					local index = 1
					local ii = 0
					for tmp in string.gmatch(alarmId, '%[*(.-)[%],]') do
						ii = ii + 1	
						if index == ii then
							alarmId_Singal = tmp;		
						end		
					end
					--
					--[[  2 ѡ һͨ 
					for tmp in string.gmatch(alarmId, '%[*(.-)[%],]') do
						alarmId_Singal = tmp;	
					end
					--]]
				else
					alarmId_Singal = alarmId
				end
				--parseRet:pushCString("AlarmID", alarmId_Singal)
			end
		end
		print("_type = ".."DeviceStatus")
		parseRet:pushCString("_type", "DeviceStatus")
	else
		return false;
	end
	
	return true;
end

function OnCatalog(root, parseRet)
	print("OnCatalog")
	total = root["SumNum"]["@Data"]
	parseRet:pushCString("@_WAIT_MSG_COUNT", total)
	total = total + 0
	if total ~= 0 then
		local num = root["DeviceList"]["@Attr"]["Num"]
		parseRet:pushCString("@_RECVED_MSG_COUNT", num)
		num = num + 0
		--עɹʱʼ
		local channelId_ALL = ATLuaConfig:instance():getConfig("ChannelID_ALL")
		local alarmId_All = ATLuaConfig:instance():getConfig("AlarmID_ALL")
		if  firstInChannelID then
			channelId_ALL = false
			alarmId_All = false
			firstInChannelID = false
		end
		if not channelId_ALL then
			channelId_ALL =""
		end
		if not alarmId_All then
			alarmId_All =""
		end
		
		channelId_ALL = string.gsub(channelId_ALL, "%[", "")
		channelId_ALL = string.gsub(channelId_ALL, "%]", "")
		alarmId_All = string.gsub(alarmId_All, "%[", "")
		alarmId_All = string.gsub(alarmId_All, "%]", "")
		if num >= 0 then
			if num > 1 then
				for k = 1,num do
					if root["DeviceList"]["Item"][k]["Status"]["@Data"] == "ON" then
						tempId = root["DeviceList"]["Item"][k]["DeviceID"]["@Data"]
						if IdType(tempId) == "VideoIn" then
							channelId_ALL = channelId_ALL..","..tempId
						elseif IdType(tempId) == "AlarmIn" then
							alarmId_All = alarmId_All..","..tempId
						end
					end
				end
			else 
				if root["DeviceList"]["Item"]["Status"]["@Data"] == "ON" then
					tempId = root["DeviceList"]["Item"]["DeviceID"]["@Data"]
					print(tempId);
					if IdType(tempId) == "VideoIn" then
						channelId_ALL = channelId_ALL..","..tempId
					elseif IdType(tempId) == "AlarmIn" then
						alarmId_All = alarmId_All..","..tempId
					end
				end
			end
			--ɵ׵ ,
			channelId_ALL = string.match(channelId_ALL, '^,*(.*)')
			alarmId_All = string.match(alarmId_All, '^,*(.*)')
			-- ","  "[]"
			if string.find(channelId_ALL, ",") then
				channelId_ALL = "["..channelId_ALL.."]"
			end
			if string.find(alarmId_All, ",") then
				alarmId_All = "["..alarmId_All.."]"
			end
			parseRet:pushCString("ChannelID_ALL", channelId_ALL)
			parseRet:pushCString("AlarmID_ALL", alarmId_All)

			--жͨ,ȡһ,
			local channelId_Singal;
			if string.find(channelId_ALL, ",") then			     
			    --[[ 1 ͨindexѡһ̨ͨ,¼
				local index = 1
				local ii = 0
				for tmp in string.gmatch(channelId_ALL, '%[*(.-)[%],]') do
					ii = ii + 1	
					if index == ii then
						channelId_Singal = tmp;		
                	end		
				end
				--]]
				--  2 ѡ һ̨ͨ,¼
				for tmp in string.gmatch(channelId_ALL, '%[*(.-)[%],]') do
					channelId_Singal = tmp;	
				end
		    else
				channelId_Singal = channelId_ALL
			end
			parseRet:pushCString("ChannelID",channelId_Singal)
		end
	end
	print("_type = ".."Catalog")
	parseRet:pushCString("_type", "Catalog")
	
	return true;
end

function OnDeviceConfig(root,parseRet)
	print("OnDeviceConfig")
	parseRet:pushCString("_type", "OnDeviceConfig")
end

function OnDeviceControl(root, parseRet)
	ATInfo("OnDeviceControl")
	alarmId = root["DeviceID"]["@Data"]
	parseRet:pushCString("AlarmID", alarmId)
	parseRet:pushCString("_type", "DeviceControl")
	
	return true;
end

function OnRecordInfo(root, parseRet)
	print("OnRecordInfo")
	total = root["SumNum"]["@Data"]
	parseRet:pushCString("@_WAIT_MSG_COUNT", total)
	total = total + 0
	
	
	local bNeedSetChannelCOnfig=false
	local currentGourpName = ATLuaConfig:instance():getConfig("@_CURRENT_GROUP_NAME")
	if currentGourpName then
		if string.find(currentGourpName,"_") then
		bNeedSetChannelCOnfig=true 
		end
	end
	
	if total ~= 0 then
		
		local num = root["RecordList"]["@Attr"]["Num"]
		print(num)
		parseRet:pushCString("@_RECVED_MSG_COUNT", num)
		num = num + 0
		
		--עɹʱʼ
		
		local Record_len = ATLuaConfig:instance():getConfig("Record_len") + 0
		local Record_Chanenel = ATLuaConfig:instance():getConfig("Record_Chanenel")
		if Record_Chanenel == root["DeviceID"]["@Data"] and Record_len > 120 then
			parseRet:pushCString("_type", "RecordInfo")
			--return
		end
		
		if num == 1 then
			value = root["RecordList"]["Item"]["StartTime"]["@Data"]
			local iyear,imonth,iday,ihour,iminute,isecond = string.match(value, "(%d+)-(%d+)-(%d+)T(%d+):(%d+):(%d+)")
			local StartTime = os.time{year=iyear,month=imonth,day=iday,hour=ihour,min=iminute,sec=isecond}

			value = root["RecordList"]["Item"]["EndTime"]["@Data"]
			iyear,imonth,iday,ihour,iminute,isecond = string.match(value, "(%d+)-(%d+)-(%d+)T(%d+):(%d+):(%d+)")
			local EndTime = os.time{year=iyear,month=imonth,day=iday,hour=ihour,min=iminute,sec=isecond}
            EndTime = StartTime + 20
			
			if EndTime-StartTime > 10 then
				Record_len = EndTime-StartTime-10
			else
				Record_len = 0
			end
			parseRet:pushCString("StartTime", StartTime)
			parseRet:pushCString("EndTime", EndTime)
			parseRet:pushCString("Record_len", Record_len)
			tmepChannel = root["DeviceID"]["@Data"]
			parseRet:pushCString("Record_Chanenel", tmepChannel)
			
			--RecordChannels
			if bNeedSetChannelCOnfig then
				RecordChannels = ATLuaConfig:instance():getConfig("RecordChannels")
				RecordChannels = AddRecordChannels(tmepChannel, RecordChannels)
				parseRet:pushCString("RecordChannels", RecordChannels)
			end
		elseif num > 1 then
			for k = 1, num do
				--[[
				if Record_len > 120 then
					break
				end
				--]]
				value = root["RecordList"]["Item"][k]["StartTime"]["@Data"]
				local iyear,imonth,iday,ihour,iminute,isecond = string.match(value, "(%d+)-(%d+)-(%d+)T(%d+):(%d+):(%d+)")
				local StartTime = os.time{year=iyear,month=imonth,day=iday,hour=ihour,min=iminute,sec=isecond}
				
				value = root["RecordList"]["Item"][k]["EndTime"]["@Data"]
				iyear,imonth,iday,ihour,iminute,isecond = string.match(value, "(%d+)-(%d+)-(%d+)T(%d+):(%d+):(%d+)")
				local EndTime = os.time{year=iyear,month=imonth,day=iday,hour=ihour,min=iminute,sec=isecond}
				EndTime = StartTime + 20
				if EndTime-StartTime > 10 then
					Record_len = EndTime-StartTime-10
				else
					Record_len = 0
				end
				parseRet:pushCString("StartTime", StartTime)
				parseRet:pushCString("EndTime", EndTime)
				parseRet:pushCString("Record_len", Record_len)
				tmepChannel = root["DeviceID"]["@Data"]
				parseRet:pushCString("Record_Chanenel", tmepChannel)
				
			end 
			
			--RecordChannels
			if bNeedSetChannelCOnfig then
				RecordChannels = ATLuaConfig:instance():getConfig("RecordChannels")
				RecordChannels = AddRecordChannels(tmepChannel, RecordChannels)
				parseRet:pushCString("RecordChannels", RecordChannels)
			end
		end
	end
	print("_type = ".."RecordInfo")
	parseRet:pushCString("_type", "RecordInfo")
	
	return true;
end

function OnConfigDownload(root, parseRet)
	ATInfo("OnConfigDownload")
	if root["VideoParamConfig"] then
	  ATInfo("VideoParamConfig")
	  parseRet:pushCString("_type", "VideoParamConfig")
    elseif root["AudioParamConfig"] then
	  ATInfo("AudioParamConfig")
      parseRet:pushCString("_type", "AudioParamConfig")
	else
	  ATInfo("BasicParam")
	  parseRet:pushCString("_type", "BasicParam")
	end
	
	return true;
end

function OnMediaStatus(root, parseRet)
	ATInfo("OnMediaStatus")
	local notifyType = root["NotifyType"]["@Data"]
	if notifyType == "121" then
	   ATInfo("FileEndStatus")
	   parseRet:pushCString("_type", "FileEndStatus")
	end
	
	return true;
end